# Class ElementKindVisitor14<R,P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,P>
javax.lang.model.util.SimpleElementVisitor6<R,P>
javax.lang.model.util.ElementKindVisitor6<R,P>
javax.lang.model.util.ElementKindVisitor7<R,P>
javax.lang.model.util.ElementKindVisitor8<R,P>
javax.lang.model.util.ElementKindVisitor9<R,P>
javax.lang.model.util.ElementKindVisitor14<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,P>`

Direct Known Subclasses:
  `ElementKindVisitorPreviewPREVIEW`

@SupportedSourceVersion(RELEASE_25) public class ElementKindVisitor14<R,P> extends ElementKindVisitor9<R,P>
A visitor of program elements based on their kind with default behavior appropriate for the `RELEASE_14` source version. For elements `Xyz` that may have more than one kind, the `visitXyz` methods in this class delegate to the `visitXyzAsKind` method corresponding to the first argument's kind. The `visitXyzAsKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  16
See Also:
  - Compatibility note for subclasses
  - `ElementKindVisitor6`
  - `ElementKindVisitor7`
  - `ElementKindVisitor8`
  - `ElementKindVisitor9`

## Field Summary

### Fields declared in class SimpleElementVisitor6

`DEFAULT_VALUE`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`ElementKindVisitor14()`
Constructor for concrete subclasses; uses `null` for the default value.
`protected`
`ElementKindVisitor14(R defaultValue)`
Constructor for concrete subclasses; uses the argument for the default value.

## Method Summary

Modifier and Type
Method
Description
`R`
`visitRecordComponent(RecordComponentElement e, P p)`
Visits a record component element.
`R`
`visitTypeAsRecord(TypeElement e, P p)`
Visits a `RECORD` type element.
`R`
`visitVariableAsBindingVariable(VariableElement e, P p)`
Visits a `BINDING_VARIABLE` variable element.

### Methods declared in class ElementKindVisitor9

`visitModule`

### Methods declared in class ElementKindVisitor7

`visitVariableAsResourceVariable`

### Methods declared in class ElementKindVisitor6

`visitExecutable, visitExecutableAsConstructor, visitExecutableAsInstanceInit, visitExecutableAsMethod, visitExecutableAsStaticInit, visitPackage, visitType, visitTypeAsAnnotationType, visitTypeAsClass, visitTypeAsEnum, visitTypeAsInterface, visitTypeParameter, visitVariable, visitVariableAsEnumConstant, visitVariableAsExceptionParameter, visitVariableAsField, visitVariableAsLocalVariable, visitVariableAsParameter`

### Methods declared in class SimpleElementVisitor6

`defaultAction`

### Methods declared in class AbstractElementVisitor6

`visit, visit, visitUnknown`

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ElementKindVisitor14

protected ElementKindVisitor14()
Constructor for concrete subclasses; uses `null` for the default value.

### ElementKindVisitor14

protected ElementKindVisitor14(R defaultValue)
Constructor for concrete subclasses; uses the argument for the default value.

Parameters:
  `defaultValue` - the value to assign to `SimpleElementVisitor6.DEFAULT_VALUE`

## Method Details

### visitRecordComponent

public R visitRecordComponent(RecordComponentElement e, P p)
Visits a record component element.

Specified by:
  `visitRecordComponent` in interface `ElementVisitor<R,P>`
Overrides:
  `visitRecordComponent` in class `AbstractElementVisitor6<R,P>`
Implementation Requirements:
  This implementation calls `defaultAction`.
Parameters:
  `e` - the element to visit
  `p` - a visitor-specified parameter
Returns:
  the result of `defaultAction`

### visitTypeAsRecord

public R visitTypeAsRecord(TypeElement e, P p)
Visits a `RECORD` type element.

Overrides:
  `visitTypeAsRecord` in class `ElementKindVisitor6<R,P>`
Implementation Requirements:
  This implementation calls `defaultAction`. .
Parameters:
  `e` - the element to visit
  `p` - a visitor-specified parameter
Returns:
  the result of `defaultAction`

### visitVariableAsBindingVariable

public R visitVariableAsBindingVariable(VariableElement e, P p)
Visits a `BINDING_VARIABLE` variable element.

Overrides:
  `visitVariableAsBindingVariable` in class `ElementKindVisitor6<R,P>`
Implementation Requirements:
  This implementation calls `defaultAction`.
Parameters:
  `e` - the element to visit
  `p` - a visitor-specified parameter
Returns:
  the result of `defaultAction`
Since:
  16